﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace Шахматы_Марка_Дворецкого
{
    public partial class FormDvoreckyChess : Form
    {
        FEN fen = new FEN();
        public int white1 = 0;
        public int white2 = 0;
        public int black1 = 0;
        public int black2 = 0;

        public FormDvoreckyChess()
        {
            InitializeComponent();
        }

        private void buttonGenerator1_Click(object sender, EventArgs e)
        {
            #region Возврат шахматной доски в начальную позицию.
            white1 = 0;
            white2 = 0;
            black1 = 0;
            black2 = 0;

            pictureBoxA2.Visible = true;
            pictureBoxA3.Visible = false;

            pictureBoxB2.Visible = true;
            pictureBoxB3.Visible = false;

            pictureBoxC2.Visible = true;
            pictureBoxC3.Visible = false;

            pictureBoxD2.Visible = true;
            pictureBoxD3.Visible = false;

            pictureBoxE2.Visible = true;
            pictureBoxE3.Visible = false;

            pictureBoxF2.Visible = true;
            pictureBoxF3.Visible = false;

            pictureBoxG2.Visible = true;
            pictureBoxG3.Visible = false;

            pictureBoxH2.Visible = true;
            pictureBoxH3.Visible = false;


            pictureBoxA7.Visible = true;
            pictureBoxA6.Visible = false;

            pictureBoxB7.Visible = true;
            pictureBoxB6.Visible = false;

            pictureBoxC7.Visible = true;
            pictureBoxC6.Visible = false;

            pictureBoxD7.Visible = true;
            pictureBoxD6.Visible = false;

            pictureBoxE7.Visible = true;
            pictureBoxE6.Visible = false;

            pictureBoxF7.Visible = true;
            pictureBoxF6.Visible = false;

            pictureBoxG7.Visible = true;
            pictureBoxG6.Visible = false;

            pictureBoxH7.Visible = true;
            pictureBoxH6.Visible = false;
            #endregion
            fen.ConvertFenToBoard();
            fen.OnePawn();
            fen.ConvertBoardToFen();

            textBoxWhite.Text = fen.InfoMooveWhite();
            textBoxBlack.Text = fen.InfoMooveBlack();
            textBoxFEN.Text = fen.InfoFEN();
            #region Передвижение пешек на доске.
            if (fen.mooveWhiteNumber.Length >= 1)
            {
                white1 = 1 + (Convert.ToInt32(Convert.ToString(fen.mooveWhiteNumber[0])));
                black1 = 1 + (Convert.ToInt32(Convert.ToString(fen.mooveBlackNumber[0])));
            }
            // White1
            switch (white1)
            {
                case 1:
                    pictureBoxA2.Visible = !pictureBoxA2.Visible;
                    pictureBoxA3.Visible = !pictureBoxA3.Visible;
                    break;
                case 2:
                    pictureBoxB2.Visible = !pictureBoxB2.Visible;
                    pictureBoxB3.Visible = !pictureBoxB3.Visible;
                    break;
                case 3:
                    pictureBoxC2.Visible = !pictureBoxC2.Visible;
                    pictureBoxC3.Visible = !pictureBoxC3.Visible;
                    break;
                case 4:
                    pictureBoxD2.Visible = !pictureBoxD2.Visible;
                    pictureBoxD3.Visible = !pictureBoxD3.Visible;
                    break;
                case 5:
                    pictureBoxE2.Visible = !pictureBoxE2.Visible;
                    pictureBoxE3.Visible = !pictureBoxE3.Visible;
                    break;
                case 6:
                    pictureBoxF2.Visible = !pictureBoxF2.Visible;
                    pictureBoxF3.Visible = !pictureBoxF3.Visible;
                    break;
                case 7:
                    pictureBoxG2.Visible = !pictureBoxG2.Visible;
                    pictureBoxG3.Visible = !pictureBoxG3.Visible;
                    break;
                case 8:
                    pictureBoxH2.Visible = !pictureBoxH2.Visible;
                    pictureBoxH3.Visible = !pictureBoxH3.Visible;
                    break;
            }
            // Black1
            switch (black1)
            {
                case 1:
                    pictureBoxA7.Visible = !pictureBoxA7.Visible;
                    pictureBoxA6.Visible = !pictureBoxA6.Visible;
                    break;
                case 2:
                    pictureBoxB7.Visible = !pictureBoxB7.Visible;
                    pictureBoxB6.Visible = !pictureBoxB6.Visible;
                    break;
                case 3:
                    pictureBoxC7.Visible = !pictureBoxC7.Visible;
                    pictureBoxC6.Visible = !pictureBoxC6.Visible;
                    break;
                case 4:
                    pictureBoxD7.Visible = !pictureBoxD7.Visible;
                    pictureBoxD6.Visible = !pictureBoxD6.Visible;
                    break;
                case 5:
                    pictureBoxE7.Visible = !pictureBoxE7.Visible;
                    pictureBoxE6.Visible = !pictureBoxE6.Visible;
                    break;
                case 6:
                    pictureBoxF7.Visible = !pictureBoxF7.Visible;
                    pictureBoxF6.Visible = !pictureBoxF6.Visible;
                    break;
                case 7:
                    pictureBoxG7.Visible = !pictureBoxG7.Visible;
                    pictureBoxG6.Visible = !pictureBoxG6.Visible;
                    break;
                case 8:
                    pictureBoxH7.Visible = !pictureBoxH7.Visible;
                    pictureBoxH6.Visible = !pictureBoxH6.Visible;
                    break;
            }
            #endregion
        }

        private void buttonGenerator2_Click(object sender, EventArgs e)
        {
            #region Возврат шахматной доски в начальную позицию.
            white1 = 0;
            white2 = 0;
            black1 = 0;
            black2 = 0;

            pictureBoxA2.Visible = true;
            pictureBoxA3.Visible = false;

            pictureBoxB2.Visible = true;
            pictureBoxB3.Visible = false;

            pictureBoxC2.Visible = true;
            pictureBoxC3.Visible = false;

            pictureBoxD2.Visible = true;
            pictureBoxD3.Visible = false;

            pictureBoxE2.Visible = true;
            pictureBoxE3.Visible = false;

            pictureBoxF2.Visible = true;
            pictureBoxF3.Visible = false;

            pictureBoxG2.Visible = true;
            pictureBoxG3.Visible = false;

            pictureBoxH2.Visible = true;
            pictureBoxH3.Visible = false;


            pictureBoxA7.Visible = true;
            pictureBoxA6.Visible = false;

            pictureBoxB7.Visible = true;
            pictureBoxB6.Visible = false;

            pictureBoxC7.Visible = true;
            pictureBoxC6.Visible = false;

            pictureBoxD7.Visible = true;
            pictureBoxD6.Visible = false;

            pictureBoxE7.Visible = true;
            pictureBoxE6.Visible = false;

            pictureBoxF7.Visible = true;
            pictureBoxF6.Visible = false;

            pictureBoxG7.Visible = true;
            pictureBoxG6.Visible = false;

            pictureBoxH7.Visible = true;
            pictureBoxH6.Visible = false;
            #endregion
            fen.ConvertFenToBoard();
            fen.OnePawnWithoutF();
            fen.ConvertBoardToFen();

            textBoxWhite.Text = fen.InfoMooveWhite();
            textBoxBlack.Text = fen.InfoMooveBlack();
            textBoxFEN.Text = fen.InfoFEN();
            #region Передвижение пешек на доске.
            if (fen.mooveWhiteNumber.Length >= 1)
            {
                white1 = 1 + (Convert.ToInt32(Convert.ToString(fen.mooveWhiteNumber[0])));
                black1 = 1 + (Convert.ToInt32(Convert.ToString(fen.mooveBlackNumber[0])));
            }
            // White1
            switch (white1)
            {
                case 1:
                    pictureBoxA2.Visible = !pictureBoxA2.Visible;
                    pictureBoxA3.Visible = !pictureBoxA3.Visible;
                    break;
                case 2:
                    pictureBoxB2.Visible = !pictureBoxB2.Visible;
                    pictureBoxB3.Visible = !pictureBoxB3.Visible;
                    break;
                case 3:
                    pictureBoxC2.Visible = !pictureBoxC2.Visible;
                    pictureBoxC3.Visible = !pictureBoxC3.Visible;
                    break;
                case 4:
                    pictureBoxD2.Visible = !pictureBoxD2.Visible;
                    pictureBoxD3.Visible = !pictureBoxD3.Visible;
                    break;
                case 5:
                    pictureBoxE2.Visible = !pictureBoxE2.Visible;
                    pictureBoxE3.Visible = !pictureBoxE3.Visible;
                    break;
                case 6:
                    pictureBoxF2.Visible = !pictureBoxF2.Visible;
                    pictureBoxF3.Visible = !pictureBoxF3.Visible;
                    break;
                case 7:
                    pictureBoxG2.Visible = !pictureBoxG2.Visible;
                    pictureBoxG3.Visible = !pictureBoxG3.Visible;
                    break;
                case 8:
                    pictureBoxH2.Visible = !pictureBoxH2.Visible;
                    pictureBoxH3.Visible = !pictureBoxH3.Visible;
                    break;
            }
            // Black1
            switch (black1)
            {
                case 1:
                    pictureBoxA7.Visible = !pictureBoxA7.Visible;
                    pictureBoxA6.Visible = !pictureBoxA6.Visible;
                    break;
                case 2:
                    pictureBoxB7.Visible = !pictureBoxB7.Visible;
                    pictureBoxB6.Visible = !pictureBoxB6.Visible;
                    break;
                case 3:
                    pictureBoxC7.Visible = !pictureBoxC7.Visible;
                    pictureBoxC6.Visible = !pictureBoxC6.Visible;
                    break;
                case 4:
                    pictureBoxD7.Visible = !pictureBoxD7.Visible;
                    pictureBoxD6.Visible = !pictureBoxD6.Visible;
                    break;
                case 5:
                    pictureBoxE7.Visible = !pictureBoxE7.Visible;
                    pictureBoxE6.Visible = !pictureBoxE6.Visible;
                    break;
                case 6:
                    pictureBoxF7.Visible = !pictureBoxF7.Visible;
                    pictureBoxF6.Visible = !pictureBoxF6.Visible;
                    break;
                case 7:
                    pictureBoxG7.Visible = !pictureBoxG7.Visible;
                    pictureBoxG6.Visible = !pictureBoxG6.Visible;
                    break;
                case 8:
                    pictureBoxH7.Visible = !pictureBoxH7.Visible;
                    pictureBoxH6.Visible = !pictureBoxH6.Visible;
                    break;
            }
            #endregion
        }

        private void buttonGenerator3_Click(object sender, EventArgs e)
        {
            #region Возврат шахматной доски в начальную позицию.
            white1 = 0;
            white2 = 0;
            black1 = 0;
            black2 = 0;

            pictureBoxA2.Visible = true;
            pictureBoxA3.Visible = false;

            pictureBoxB2.Visible = true;
            pictureBoxB3.Visible = false;

            pictureBoxC2.Visible = true;
            pictureBoxC3.Visible = false;

            pictureBoxD2.Visible = true;
            pictureBoxD3.Visible = false;

            pictureBoxE2.Visible = true;
            pictureBoxE3.Visible = false;

            pictureBoxF2.Visible = true;
            pictureBoxF3.Visible = false;

            pictureBoxG2.Visible = true;
            pictureBoxG3.Visible = false;

            pictureBoxH2.Visible = true;
            pictureBoxH3.Visible = false;


            pictureBoxA7.Visible = true;
            pictureBoxA6.Visible = false;

            pictureBoxB7.Visible = true;
            pictureBoxB6.Visible = false;

            pictureBoxC7.Visible = true;
            pictureBoxC6.Visible = false;

            pictureBoxD7.Visible = true;
            pictureBoxD6.Visible = false;

            pictureBoxE7.Visible = true;
            pictureBoxE6.Visible = false;

            pictureBoxF7.Visible = true;
            pictureBoxF6.Visible = false;

            pictureBoxG7.Visible = true;
            pictureBoxG6.Visible = false;

            pictureBoxH7.Visible = true;
            pictureBoxH6.Visible = false;
            #endregion
            fen.ConvertFenToBoard();
            fen.TwoPawn();
            fen.ConvertBoardToFen();

            textBoxWhite.Text = fen.InfoMooveWhite();
            textBoxBlack.Text = fen.InfoMooveBlack();
            textBoxFEN.Text = fen.InfoFEN();
            #region Передвижение пешек на доске.
            if (fen.mooveWhiteNumber.Length >= 1)
            {
                white1 = 1 + (Convert.ToInt32(Convert.ToString(fen.mooveWhiteNumber[0])));
                black1 = 1 + (Convert.ToInt32(Convert.ToString(fen.mooveBlackNumber[0])));
            }
            if (fen.mooveWhiteNumber.Length >= 2)
            {
                white2 = 1 + (Convert.ToInt32(Convert.ToString(fen.mooveWhiteNumber[1])));
                black2 = 1 + (Convert.ToInt32(Convert.ToString(fen.mooveBlackNumber[1])));
            }
            // White1
            switch (white1)
            {
                case 1:
                    pictureBoxA2.Visible = !pictureBoxA2.Visible;
                    pictureBoxA3.Visible = !pictureBoxA3.Visible;
                    break;
                case 2:
                    pictureBoxB2.Visible = !pictureBoxB2.Visible;
                    pictureBoxB3.Visible = !pictureBoxB3.Visible;
                    break;
                case 3:
                    pictureBoxC2.Visible = !pictureBoxC2.Visible;
                    pictureBoxC3.Visible = !pictureBoxC3.Visible;
                    break;
                case 4:
                    pictureBoxD2.Visible = !pictureBoxD2.Visible;
                    pictureBoxD3.Visible = !pictureBoxD3.Visible;
                    break;
                case 5:
                    pictureBoxE2.Visible = !pictureBoxE2.Visible;
                    pictureBoxE3.Visible = !pictureBoxE3.Visible;
                    break;
                case 6:
                    pictureBoxF2.Visible = !pictureBoxF2.Visible;
                    pictureBoxF3.Visible = !pictureBoxF3.Visible;
                    break;
                case 7:
                    pictureBoxG2.Visible = !pictureBoxG2.Visible;
                    pictureBoxG3.Visible = !pictureBoxG3.Visible;
                    break;
                case 8:
                    pictureBoxH2.Visible = !pictureBoxH2.Visible;
                    pictureBoxH3.Visible = !pictureBoxH3.Visible;
                    break;
            }
            // White2
            switch (white2)
            {
                case 1:
                    pictureBoxA2.Visible = !pictureBoxA2.Visible;
                    pictureBoxA3.Visible = !pictureBoxA3.Visible;
                    break;
                case 2:
                    pictureBoxB2.Visible = !pictureBoxB2.Visible;
                    pictureBoxB3.Visible = !pictureBoxB3.Visible;
                    break;
                case 3:
                    pictureBoxC2.Visible = !pictureBoxC2.Visible;
                    pictureBoxC3.Visible = !pictureBoxC3.Visible;
                    break;
                case 4:
                    pictureBoxD2.Visible = !pictureBoxD2.Visible;
                    pictureBoxD3.Visible = !pictureBoxD3.Visible;
                    break;
                case 5:
                    pictureBoxE2.Visible = !pictureBoxE2.Visible;
                    pictureBoxE3.Visible = !pictureBoxE3.Visible;
                    break;
                case 6:
                    pictureBoxF2.Visible = !pictureBoxF2.Visible;
                    pictureBoxF3.Visible = !pictureBoxF3.Visible;
                    break;
                case 7:
                    pictureBoxG2.Visible = !pictureBoxG2.Visible;
                    pictureBoxG3.Visible = !pictureBoxG3.Visible;
                    break;
                case 8:
                    pictureBoxH2.Visible = !pictureBoxH2.Visible;
                    pictureBoxH3.Visible = !pictureBoxH3.Visible;
                    break;
            }
            // Black1
            switch (black1)
            {
                case 1:
                    pictureBoxA7.Visible = !pictureBoxA7.Visible;
                    pictureBoxA6.Visible = !pictureBoxA6.Visible;
                    break;
                case 2:
                    pictureBoxB7.Visible = !pictureBoxB7.Visible;
                    pictureBoxB6.Visible = !pictureBoxB6.Visible;
                    break;
                case 3:
                    pictureBoxC7.Visible = !pictureBoxC7.Visible;
                    pictureBoxC6.Visible = !pictureBoxC6.Visible;
                    break;
                case 4:
                    pictureBoxD7.Visible = !pictureBoxD7.Visible;
                    pictureBoxD6.Visible = !pictureBoxD6.Visible;
                    break;
                case 5:
                    pictureBoxE7.Visible = !pictureBoxE7.Visible;
                    pictureBoxE6.Visible = !pictureBoxE6.Visible;
                    break;
                case 6:
                    pictureBoxF7.Visible = !pictureBoxF7.Visible;
                    pictureBoxF6.Visible = !pictureBoxF6.Visible;
                    break;
                case 7:
                    pictureBoxG7.Visible = !pictureBoxG7.Visible;
                    pictureBoxG6.Visible = !pictureBoxG6.Visible;
                    break;
                case 8:
                    pictureBoxH7.Visible = !pictureBoxH7.Visible;
                    pictureBoxH6.Visible = !pictureBoxH6.Visible;
                    break;
            }
            // Black2
            switch (black2)
            {
                case 1:
                    pictureBoxA7.Visible = !pictureBoxA7.Visible;
                    pictureBoxA6.Visible = !pictureBoxA6.Visible;
                    break;
                case 2:
                    pictureBoxB7.Visible = !pictureBoxB7.Visible;
                    pictureBoxB6.Visible = !pictureBoxB6.Visible;
                    break;
                case 3:
                    pictureBoxC7.Visible = !pictureBoxC7.Visible;
                    pictureBoxC6.Visible = !pictureBoxC6.Visible;
                    break;
                case 4:
                    pictureBoxD7.Visible = !pictureBoxD7.Visible;
                    pictureBoxD6.Visible = !pictureBoxD6.Visible;
                    break;
                case 5:
                    pictureBoxE7.Visible = !pictureBoxE7.Visible;
                    pictureBoxE6.Visible = !pictureBoxE6.Visible;
                    break;
                case 6:
                    pictureBoxF7.Visible = !pictureBoxF7.Visible;
                    pictureBoxF6.Visible = !pictureBoxF6.Visible;
                    break;
                case 7:
                    pictureBoxG7.Visible = !pictureBoxG7.Visible;
                    pictureBoxG6.Visible = !pictureBoxG6.Visible;
                    break;
                case 8:
                    pictureBoxH7.Visible = !pictureBoxH7.Visible;
                    pictureBoxH6.Visible = !pictureBoxH6.Visible;
                    break;
            }
            #endregion
        }

        private void buttonGenerator4_Click(objeBoxE6.Visible = !pictureBoxE6.Visible;
                    break;
                case 6:
                    pictureBoxF7.Visible = !pictureBoxF7.Visible;
                    pictureBoxF6.Visible = !pictureBoxF6.Visible;
                    break;
  tureBoxA2.Visible = true;
            pictureBoxA3.Visible = false;

            pictureBoxB2.Visible = true;
            pictureBoxB3.Visible = false;

            pictureBoxC2.Visible = true;
            pictureBoxC3.Visible = false;

            pictureBoxD2.Visible = true;
            pictureBoxD3.Visible = false;

            pictureBoxE2.Visible = true;
            pictureBoxE3.Visible = false;

            pictureBoxF2.Visible = true;
            pictureBoxF3.Visible = false;

            pictureBoxG2.Visible = true;
            pictureBoxG3.Visible = false;

            pictureBoxH2.Visible = true;
            pictureBoxH3.Visible = false;


            pictureBoxA7.Visible = true;
            pictureBoxA6.Visible = false;

            pictureBoxB7.Visible = true;
            pictureBoxB6.Visible = false;

            pictureBoxC7.Visible = true;
            pictureBoxC6.Visible = false;

            pictureBoxD7.Visible = true;
            pictureBoxD6.Visible = false;

            pictureBoxE7.Visible = true;
            pictureBoxE6.Visible = false;

            pictureBoxF7.Visible = true;
            pictureBoxF6.Visible = false;

            pictureBoxG7.Visible = true;
            pictureBoxG6.Visible = false;

            pictureBoxH7.Visible = true;
            pictureBoxH6.Visible = false;
            #endregion
            fen.ConvertFenToBoard();
            fen.TwoPawnWithoutF();
            fen.ConvertBoard

            pictureBoxB7.Visible = true;
            pictureBoxB6.Visible = false;

            pictureBoxC7.Visible = true;
            pictureBoxC6.Visible = false;

            pictureBoxD7.Visible = true;
            pictureBoxD6.Visible = fa(fen.mooveWhiteNumber.Length >=7.Visible = true;
            pictureBoxE6.Visible = false;

            pictureBoxF7.Visible = true;
            pictureBoxF6.Visible = false;

            pictureBoxG7.Visible = true;
            pictureBoxG6.Visible = false;

            pictureength >= 2)
            {
                whi.Visible = false;
            #endregion
            fen.ConvertFenToBoard();
            fen.TwoPawnWithoutF();
            fen.ConvertBoard

            pictureBoxB7.Visible = true;
            pictureBoxB6.Visible = false;

            pictureBo      case 1:
                    pictureBoxA2.Visible = !pictureBoxA2.Visible;
                    pictureBoxA3.Visible = !pictureBoxA3.Visible;
                    break;
                case 2:
                    pictureBoxB2.Visible = !pictureBoxB2.Visible;
                    pictureBoxB3.Visible = !pictureBoxB3.Visible;
                    break;
                case 3:
                    pictureBoxC2.Visible = !pictureBoxC2.Visible;
                    pictureBoxC3.Visible = !pictureBoxC3.Visible;
                    break;
                case 4:
                    pictureBoxD2.Visible = !pictureBoxD2.Visible;
                    pictureBoxD3.Visible = !pictureBoxD3.Visible;
                    break;
                case 5:
                    pictureBoxE2.Visible = !pictureBoxE2.Visible;
                    pictureBoxE3.Visible = !pictureBoxE3.Visible;
                    break;
                case 6:
                    pictureBoxF2.Visible = !pictureBoxF2.Visible;
                    pictureBoxF3.Visible = !pictureBoxF3.Visible;
                    break;
                case 7:
                    pictureBoxG2.Visible = !pictureBoxG2.Visible;
                    pictureBoxG3.Visible = !pictureBoxG3.Visible;
                    break;
                case 8:
                    pictureBoxH2.Visible = !pictureBoxH2.Visible;
                    pictureBoxH3.Visible = !pictureBoxH3.Visible;
                    break;
            }
            // Whi pictureBoxE2.Visible = !pictureBoxE2.Visible;
                    pictureBoxE3.Visible = !pictureBoxE3.Visible;
                    break;
                case 6:
                    pictureBoxF2.Visible = !pictureBoxF2.Visible;
                    pi2:
                    pictureBoxB2.Visible = !pictureBoxB2.Visible;
                    pictureBoxB3.Visible = !pictureBoxB3.Visible;
                    break;
                case 3:
                    pictureBoxC2.Visible = !pictureBoxC2.Visible;
                    pictureBoxC3.Visible = !pictureBoxC3.Visible;
                    break;
                case 4:
                    pictureBoxD2.Visible = !pictureBoxD2.Visible;
                    pictureBoxD3.Visible = !pictureBoxD3.Visible;
                    break;
                case 5:
                    pictureBoxE2.Visible = !pictureBoxE2.Visible;
                    pictureBoxE3.Visible = !pictureBoxE3.Visible;
                    break;
                case 6:
                    pictureBoxF2.Visible = !pictureBoxF2.Visible;
                    pictureBoxF3.Visible = !pictureBoxF3.Visible;
                    break;
                case 7:
                    pictureBoxG2.Visible = !pictureBoxG2.Visible;
                    pictureBoxG3.Visible = !pictureBoxG3.Visible;
                    break;
                case 8:
                    pictureBoxH2.Visible = !pictureBoxH2.Visible;
                    pictureBoxH3.Visible = !pictureBoxH3.Visible;
                    break;
            }
            // Black1
            switch (black1)
            {
                case 1:
                    pictureBoxA7.Visible = !pictureBoxA7.Visible;
                    pictureBoxA6.Visible = !pictureBoxA6.Visible;
                    break;
                case 2:
                    pictureBoxB7.Visible = !pictureBoxB7.Visible;
                    pictureBoxB6.Visible = !pictureBoxB6.Visible;
                    break;
                case 3:
                    pictureBoxC7.Visible = !pictureBoxC7.Visible;
                    pictureBoxC6.Visible = !pictureBoxC6.Visible;
                    break;
                case 4:
                    pictureBoxD7.Visible = !pictureBoxD7.Visible;
                    pictureBoxD6.Visible = !pictureBoxD6.Visible;
                    break;
                case 5:
                    pictureBoxE7.Visible = !pictureBoxE7.Visible;
                    pictureBoxE6.Visible = !pictureBoxE6.Visible;
                    break;
                case 6:
                    pictureBoxF7.Visible = !pictureBoxF7.Visible;
                    pictureBoxF6.Visible = !pictureBoxF6.Visible;
                    break;
                case 7:
                    pictureBoxG7.Visible = !pictureBoxG7.Visible;
                    pictureBoxG6.Visible = !pictureBoxG6.Visible;
                    break;
                case 8:
                    pictureBoxH7.Visible = !pictureBoxH7.Visible;
                    pictureBoxH6.Visible = !pictureBoxH6.Visible;
                    break;
            }
            // Black2
            switch (blatureBoxE7.Visible;
                    pictureBoxE6.Visible = !pictureBoxE6.Visible;
                    break;
                case 6:
                    pictureBoxF7.Visible = !pictureBoxF7.Visible;
                    pictureBoxF6.Visible = !picturureBoxB7.Visible = !pictureBoxB7.Visible;
                    pictureBoxB6.Visible = !pictureBoxB6.Visible;
                    break;
                case 3:
                    pictureBoxC7.Visible = !pictureBoxC7.Visible;
                    pictureBoxC6.Visible = !pictureBoxC6.Visible;
                    break;
                case 4:
                    pictureBoxD7.Visible = !pictureBoxD7.Visible;
                    pictureBoxD6.Visible = !pictureBoxD6.Visible;
                    break;
                case 5:
                    pictureBoxE7.Visible = !pictureBoxE7.Visible;
                    pictureBoxE6.Visible = !pictureBoxE6.Visible;
                    break;
                case 6:
                    pictureBoxF7.Visible = !pictureBoxF7.Visible;
                    pictureBoxF6.Visible = !pictureBoxF6.Visible;
                    break;
                case 7:
                    pictureBoxG7.Visible = !pictureBoxG7.Visible;
                    pictureBoxG6.Visible = !pictureBoxG6.Visible;
                    break;
                case 8:
                    pictureBoxH7.Visible = !pictureBoxH7.Visible;
                    pictureBoxH6.Visible = !pictureBoxH6.Visible;
                    break;
            }
            #endregion
        }

        private void buttonHelp_Click(object sender, EventArgs e)
        {
            MessageBox.Show(@"Программа является генератором стартовой позиции. Берем обычную начальную позицию. Делаем белыми и черными по жребию по ходу пешкой (или двумя) вперед на одну клетку (причем ходы — не обязательно симметричные), а уж затем начинаем играть.

6. Альтернативное предложение (Вырезка из статьи Марка Дворецкого)

Психологически нелегко уходить от вековых традиций. Если уж это приходится делать, желательно добиваться поставленной цели (в данном случае — избавления от дебютной теории) наиболее экономичным путем, идя на минимальные изменения. В связи с этим предложу иной путь, менее радикальный, нежели шахматы Фишера. Берем обычную начальную позицию. Делаем белыми и черными по жребию по ходу пешкой вперед на одну клетку (причем ходы — не обязательно симметричные), а уж затем начинаем играть. Всего получается 64 варианта стартовой позиции, в некоторых из них преимущество выступки чуть уменьшилось, в некоторых — чуть увеличилось, но это не страшно. Вероятно, некоторые сочетания ходов дают слишком уж значительное преимущество одной из сторон (например, после 1.d3 f6 у черных большие трудности с развитием королевского коня) — исключим их. Останется примерно 50 вариантов. Это число может быть увеличено, если добавить в жеребьевку также ходы коней (но не все — например, после 1.Of3 Of6 получается позиция, многократно встречавшаяся на практике, что нежелательно). Если же покажется необходимым резко увеличить число начальных позиций, то можно делать не по одному, а по два хода за каждую сторону — тогда наберется несколько сотен вариантов, неизвестных современной теории и в то же время практически не нарушающих баланс сил. Впрочем, и одной пары ходов достаточно для вывода из обращения теперешней теории. А новая теория, которая неизбежно появится, уже не будет нагромождением сыгранных партий и компьютерных разработок (не зная, какая позиция играется и как ее трактует партнер, нет смысла забивать себе голову бесконечными анализами). Изучаться будут основные стратегические мотивы различных начальных расстановок (например, если сделан ход f2-f3, то целесообразно развитие коня через h3 на f2), а также возможности приспособления к новым условиям тех или иных планов, изученных в традиционных шахматах. Ведь позиции будут получаться очень похожими на привычные нам, а потому принципы дебютной стратегии мало изменятся, многовековой опыт трактовки дебюта по-прежнему останется на вооружении шахматистов.

Мы видим, что предлагаемая форма шахмат достигает той же цели, что и chess-960: освобождает шахматистов от изнурительной домашней подготовки и обязывает их думать самостоятельно с самых первых ходов. Но изменения происходят менее радикальные (в привычную позицию вносится лишь один-два новых элемента), шахматистам проще к ним приспособиться и существенного снижения качества игры не произойдет. Сохраняется все самое ценное из накопленного наследия, в том числе и лучшие образцы решения дебютных проблем (поскольку решать придется очень похожие задачи). Да и технически (запись партии, использование компьютерных программ) перейти на такой вариант игры намного проще чем на фишеррэндом, поскольку за основу берется обычная начальная позиция.

Отдадим должное американскому гроссмейстеру, он не просто подал идею произвольной расстановки фигур в начальной позиции (такая идея выдвигалась и раньше), но разработал четкие правила новой игры. Я же лишь описал схему, которая требует определенной доработки, правда, не слишком сложной. Было бы хорошо, если бы моим предложением заинтересовались и проверили его на практике. Несколько соревнований, проведенных по этим правилам (так же как и по правилам Фишера) помогли бы лучше оценить новые варианты игры, выявить их сильные и слабые стороны. Если та или иная из новых форм шахмат завоюет популярность, она неизбежно приобретет официальный статус, и вот тогда-то станет возможным постепенный переход большинства любителей и профессионалов к шахматам, в которых партнеры будут меряться мастерством, а не результатами работы домашних компьютеров и способностью их запомнить. Будущее покажет, останутся ли утопией подобные проекты или превратятся в реальность.

Полный текст статьи был опубликован в журнале ""64"" №1 за 2008 год. Прочитать статью можно по адресу: www.64.ru


D.Chess - Программа с открытым исходным кодом.
Распространяется под лицензией: CC BY-NC-SA 3.0
(Creative Commons Attribution-NonCommercial-ShareAlike 3.0)
Разрешено свободное использование произведения, при условии указания его автора(ов) и только в некоммерческих целях. Также все производные произведения, должны распространяться под лицензией CC BY-NC-SA 3.0");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Clipboard.SetDataObject(textBoxFEN.Text);
        }

        private void linkHome_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Process.Start("http://mosc.bursa.ru");
        }

        private void linkLicense_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Process.Start("http://creativecommons.org/licenses/by-nc-sa/3.0/deed.ru");
        }
    }
}
